'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _Query = require('./Query');

var _Query2 = _interopRequireDefault(_Query);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

/**
 * Authencation wrapper for getting a token from the service.
 *
 * Makes a request to the `_session` endpoint using `Query` and keeps track of
 * the token received in an appropriate header to pass into following `Query`
 * calls instead of an `auth` object.
 *
 * @param {Object} params
 * @param {Object} params.auth - Auth object passed into Query for the service
 * @param {String} params.uri - String for the URI of the Service
 * @returns {Object}
 */
var Auth = function () {
  var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(_ref) {
    var auth = _ref.auth;
    var uri = _ref.uri;
    var debug = _ref.debug;

    var options, _ref2, token, headers;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            (0, _invariant2.default)(uri, 'A valid URI needs to be supplied for the Authentication modules to ' + 'work. Expected a string representing the instance URL, instead got %s.', uri);

            options = {
              uri: uri.slice(0, uri.length - 2) + '/_session',
              method: 'GET',
              debug: debug,
              auth: auth
            };
            _context.prev = 2;
            _context.next = 5;
            return (0, _Query2.default)(options);

          case 5:
            _ref2 = _context.sent;
            token = _ref2['gds-token'];
            headers = {
              Authorization: 'gds-token ' + token
            };
            return _context.abrupt('return', { headers: headers });

          case 11:
            _context.prev = 11;
            _context.t0 = _context['catch'](2);
            return _context.abrupt('return', _context.t0);

          case 14:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[2, 11]]);
  })),
      _this = undefined;

  return function Auth(_x) {
    return ref.apply(_this, arguments);
  };
}();

exports.default = Auth;