'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _Query = require('./Query');

var _Query2 = _interopRequireDefault(_Query);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

var types = {
  graphson: 'json',
  graphml: 'xml'
};

var Load = function Load(_ref) {
  var auth = _ref.auth;
  var uri = _ref.uri;
  var filePath = _ref.filePath;
  var type = _ref.type;
  var debug = _ref.debug;
  return new Promise(function (resolve, reject) {
    var t = type.toLowerCase();

    (0, _invariant2.default)(types[t], 'Expected `type` supplied to `Load` to be one of [GraphSON, GraphML]. ' + 'Instead got %s.', type);

    _fs2.default.readFile(filePath, function () {
      var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(err, data) {
        var _formData;

        var bulkUploadURI, formData, response;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!err) {
                  _context.next = 3;
                  break;
                }

                reject(err);
                return _context.abrupt('return');

              case 3:
                bulkUploadURI = uri + '/bulkload/' + t;
                formData = (_formData = {}, _defineProperty(_formData, t, _fs2.default.createReadStream(filePath)), _defineProperty(_formData, 'type', 'application/' + types[t]), _formData);
                _context.next = 7;
                return (0, _Query2.default)({
                  auth: auth,
                  method: 'POST',
                  uri: bulkUploadURI,
                  formData: formData,
                  debug: debug
                });

              case 7:
                response = _context.sent;

                if (response.result) {
                  _context.next = 11;
                  break;
                }

                reject(response);
                return _context.abrupt('return');

              case 11:

                resolve(result.data[0]);

              case 12:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x, _x2) {
        return ref.apply(this, arguments);
      };
    }());
  });
};

exports.default = Load;