'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Auth = require('./Auth');

var _Auth2 = _interopRequireDefault(_Auth);

var _Query = require('./Query');

var _Query2 = _interopRequireDefault(_Query);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

/**
 * Creates a new session with the service, wrapping any query with the
 * appropriate Authentication header that includes the `gds-token` from
 * invoking `Auth`.
 *
 * @param {Object} params
 * @param {Object} params.auth - Auth object used to authenticate
 * @param {String} params.uri - The URI string for the service
 * @returns {Object}
 */
var Session = function () {
  var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(_ref) {
    var auth = _ref.auth;
    var uri = _ref.uri;
    var debug = _ref.debug;

    var _ref2, headers, query;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _Auth2.default)({ auth: auth, uri: uri, debug: debug });

          case 2:
            _ref2 = _context2.sent;
            headers = _ref2.headers;

            query = function () {
              var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(_ref3) {
                var uri = _ref3.uri;
                var method = _ref3.method;
                var body = _ref3.body;
                var result;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return (0, _Query2.default)({ uri: uri, method: method, body: body, headers: headers, debug: debug });

                      case 2:
                        result = _context.sent;
                        return _context.abrupt('return', result);

                      case 4:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, undefined);
              })),
                  _this = undefined;

              return function query(_x2) {
                return ref.apply(_this, arguments);
              };
            }();

            return _context2.abrupt('return', {
              query: query
            });

          case 6:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  })),
      _this = undefined;

  return function Session(_x) {
    return ref.apply(_this, arguments);
  };
}();

exports.default = Session;