'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FollowsEdge = exports.AuthorEdge = exports.TweetedEdge = undefined;

var _multiplicity = require('../../schema/multiplicity');

var _properties = require('./properties');

var TweetedEdge = exports.TweetedEdge = {
  name: 'tweeted',
  multiplicity: _multiplicity.multiplicity.ManyToOne,
  directed: true
};

var AuthorEdge = exports.AuthorEdge = {
  name: 'author',
  multiplicity: _multiplicity.multiplicity.OneToMany,
  directed: true
};

var FollowsEdge = exports.FollowsEdge = {
  name: 'follows',
  multiplicity: _multiplicity.multiplicity.Multi,
  directed: true,
  properties: [_properties.FollowedProperty]
};