'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FollowedProperty = exports.TimeProperty = exports.TextProperty = exports.NameProperty = undefined;

var _dataTypes = require('../../schema/dataTypes');

var _cardinality = require('../../schema/cardinality');

var NameProperty = exports.NameProperty = {
  name: 'name',
  dataType: _dataTypes.dataTypes.String,
  cardinality: _cardinality.cardinality.Single,
  index: {
    name: 'nameIndex',
    unique: false,
    composite: true,
    indexOnly: false
  }
};

var TextProperty = exports.TextProperty = {
  name: 'text',
  dataType: _dataTypes.dataTypes.String,
  cardinality: _cardinality.cardinality.Single,
  index: {
    name: 'textIndex',
    unique: false,
    composite: true,
    indexOnly: false
  }
};

var TimeProperty = exports.TimeProperty = {
  name: 'time',
  dataType: _dataTypes.dataTypes.Integer,
  cardinality: _cardinality.cardinality.Single
};

var FollowedProperty = exports.FollowedProperty = {
  name: 'followed',
  dataType: _dataTypes.dataTypes.Integer,
  cardinality: _cardinality.cardinality.Single,
  index: {
    name: 'followedIndex',
    unique: false,
    composite: true,
    indexOnly: false
  }
};