'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TweetVertex = exports.UserVertex = undefined;

var _edges = require('./edges');

var _properties = require('./properties');

var UserVertex = exports.UserVertex = {
  name: 'user',
  properties: [_properties.NameProperty],
  inEdges: [_edges.FollowsEdge],
  outEdges: [_edges.TweetedEdge, _edges.FollowsEdge]
};

var TweetVertex = exports.TweetVertex = {
  name: 'tweet',
  properties: [_properties.TextProperty, _properties.TimeProperty],
  inEdges: [_edges.TweetedEdge],
  outEdges: [_edges.AuthorEdge]
};